package com.tzld.piaoquan.recommend.server.service.score.feature;

import com.tzld.piaoquan.recommend.server.common.base.*;
import com.tzld.piaoquan.recommend.server.common.enums.VlogFeatureGroup;
import com.tzld.piaoquan.recommend.server.gen.recommend.*;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class VlogShareLRFeatureExtractor extends LRBytesFeatureExtractorBase {

    public VlogShareLRFeatureExtractor() {
        super();
    }
    public VlogShareLRFeatureExtractor(FeatureUsage usage) {
        super(usage);
    }
    public VlogShareLRFeatureExtractor(FeatureUsage usage, double userCtrGroup, double videoCtrGroup) {
        super(usage, userCtrGroup, videoCtrGroup);
    }


    // TODO
    // 补充待抽取的context feature
    private void getContextFeatures(RequestContextBytesFeature requestContextBytes) {
        makeFea(VlogFeatureGroup.DAY_OF_WEEK, "1".getBytes());

    }

    //TODO
    private void getUserFeatures(UserBytesFeature user) {
        makeFea(VlogFeatureGroup.SEX, user.sex);

    }

    private void getItemFeature(VideoBytesFeature videoBytesFeature) {
        makeFea(VlogFeatureGroup.VIDEOID, videoBytesFeature.videoId);
    }

    @Override
    public synchronized LRSamples single(UserBytesFeature userBytesFeature,
                            VideoBytesFeature videoBytesFeature,
                            RequestContextBytesFeature requestContextBytesFeature) {
        features.clear();
        //
        getUserFeatures(userBytesFeature);
        getContextFeatures(requestContextBytesFeature);
        getItemFeature(videoBytesFeature);

        LRSamples.Builder lr =  com.tzld.piaoquan.recommend.server.gen.recommend.LRSamples.newBuilder();
        lr.setGroupNum(groupCount);
        List<FeatureGroup> keys = new ArrayList<>(features.keySet());
        int count = 0;
        for(FeatureGroup group : keys) {
            List<BaseFeature> fea = features.get(group);
            GroupedFeature.Builder gf = GroupedFeature.newBuilder();
            gf.setGroup(group);
            gf.setCount(fea.size());
            gf.addAllFeatures(fea);
            count += fea.size();
            lr.addFeatures(gf);
        }
        lr.setCount(count);
        return lr.build();
    }












}
